# -*- coding: utf-8 -*-

from aliyunsdkdyplsapi.request.v20170525 import BindAxbRequest
from aliyunsdkdyplsapi.request.v20170525 import BindAxnRequest
from aliyunsdkdyplsapi.request.v20170525 import UnbindSubscriptionRequest
from aliyunsdkdyplsapi.request.v20170525 import BindAxnExtensionRequest
from aliyunsdkcore.client import AcsClient
from aliyunsdkcore.profile import region_provider

"""
隐私保护服务调用接口示例，版本号：v20170525

Created on 2017-09-18

"""

# 注意：不要更改
REGION = "cn-hangzhou"
PRODUCT_NAME = "Dyplsapi"
DOMAIN = "dyplsapi.aliyuncs.com"

# ACCESS_ID/ACCESS_KEY TODO 此处需要替换成开发者自己的AK(在阿里云访问控制台寻找)
ACCESS_KEY_ID = "$yourAccessKeyId"
ACCESS_KEY_SECRET = "$yourAccessKeySecret"

# 初始化acsClient,暂不支持region化
acs_client = AcsClient(ACCESS_KEY_ID, ACCESS_KEY_SECRET, REGION)
region_provider.add_endpoint(PRODUCT_NAME,REGION,DOMAIN)


# 绑定Axb号码示例方法
def bind_axb_demo():
    # 组装请求对象 - 具体描述见控制台 - 文档部分内容
    bind_axb_request = BindAxbRequest.BindAxbRequest()

    # 必填:对应的号池Key
    bind_axb_request.set_PoolKey("FC12345678");
    # 必填:AXB关系中的A号码
    bind_axb_request.set_PhoneNoA("15010101010");
    # 必填:AXB关系中的B号码
    bind_axb_request.set_PhoneNoB("15020202020");
    # 必填:绑定关系对应的失效时间 - 不能早于当前系统时间1分钟
    bind_axb_request.set_Expiration("2017-09-18 17:00:00");
    # 可选:是否需要录制音频 - 默认是false
    bind_axb_request.set_IsRecordingEnabled(False);

    # 外部业务自定义ID属性
    bind_axb_request.set_OutId("yourOutId");

    # 调用远程接口，返回json
    bind_axb_response = acs_client.do_action_with_exception(bind_axb_request)

    # TODO 业务处理

    return bind_axb_response


# 绑定Axn号码示例方法
def bind_axn_demo():
    # 组装请求对象 - 具体描述见控制台 - 文档部分内容
    bind_axn_request = BindAxnRequest.BindAxnRequest()

    # 必填:对应的号池Key
    bind_axn_request.set_PoolKey("FC12345678");
    # 必填:AXN关系中的A号码
    bind_axn_request.set_PhoneNoA("15905712037");
    # 可选:AXN中A拨打X的时候转接到的默认的B号码, 如果不需要则不设置
    bind_axn_request.set_PhoneNoB("17005710796");
    # 必填:绑定关系对应的失效时间 - 不能早于当前系统时间1分钟
    bind_axn_request.set_Expiration("2017-09-18 17:00:00");
    # 可选:是否需要录制音频 - 默认是false
    bind_axn_request.set_IsRecordingEnabled(False);

    # 外部业务自定义ID属性
    bind_axn_request.set_OutId("yourOutId");
    # AXN的隐私号码X一共支持2种号码类型 NO_95 NO_170
    bind_axn_request.set_NoType("NO_95");

    # 调用远程接口，返回json
    bind_axn_response = acs_client.do_action_with_exception(bind_axn_request)

    # TODO 业务处理

    return bind_axn_response


# 绑定AXN分机号绑定示例方法
def bind_axn_extension_demo():
    # 组装请求对象 - 具体描述见控制台 - 文档部分内容
    bind_axn_extension_request = BindAxnExtensionRequest.BindAxnExtensionRequest()

    # 必填:对应的号池Key
    bind_axn_extension_request.set_PoolKey("FC100000025200443");
    # 必填:AXN关bind_axb_request系中的A号码
    bind_axn_extension_request.set_PhoneNoA("18673166686");
    # 可选:分机号，如果不填，自动分配1-3位
    bind_axn_extension_request.set_Extension("112");
    # 必填:绑定关系对应的失效时间-不能早于当前系统时间
    bind_axn_extension_request.set_Expiration("2018-06-28 17:00:00");
    # 可选:是否需要录制音频-默认是false
    bind_axn_extension_request.set_IsRecordingEnabled(False);

    # 外部业务自定义ID属性
    bind_axn_extension_request.set_OutId("199");

    # 调用远程接口，返回json
    bind_axn_extension_response = acs_client.do_action_with_exception(bind_axn_extension_request)

    # TODO 业务处理

    return bind_axn_extension_response


# 解绑号码示例
def unbind():
    # 组装请求对象 - 具体描述见控制台 - 文档部分内容
    unbind_subscription_request = UnbindSubscriptionRequest.UnbindSubscriptionRequest()

    # 必填 - 分配的X号码 - 对应到绑定接口中返回的secretNo;
    unbind_subscription_request.set_SecretNo("1700000000");
    # 可选 - 绑定关系对应的ID - 对应到绑定接口中返回的subsId;
    unbind_subscription_request.set_SubsId("728884086");

    # 调用远程接口，返回json
    unbind_subscription_response = acs_client.do_action_with_exception(unbind_subscription_request)

    # TODO 业务处理

    return unbind_subscription_response


# 测试
__name__ = 'bind_axn_extension_demo'
if __name__ == 'bind_axb_demo':
    print (bind_axb_demo())

if __name__ == 'bind_axn_demo':
    print (bind_axn_demo())

if __name__ == 'bind_axn_extension_demo':
    print (bind_axn_extension_demo())

if __name__ == 'unbind':
    print (unbind())
